#include "Enemy.h"

Enemy::Enemy( float x_in, float y_in, float vx_in, float vy_in )
	:
	x( x_in ),
	y( y_in ),
	vx( vx_in ),
	vy( vy_in )
{
}

void Enemy::Move( Board & Brd, int TileSize, float DeltaTime )
{
	{
		x += vx * DeltaTime;

		const auto ix = static_cast< int >( x );
		const auto iy = static_cast< int >( y );
		const auto curTileX = ix / TileSize;
		const auto curTileY = iy / TileSize;
		const auto nextTileX = curTileX + 1;

		if( Brd.GetTileType( curTileX, curTileY ) == Board::Type::filled ||
			Brd.GetTileType( nextTileX, curTileY ) == Board::Type::filled )
		{
			vx = -vx;
			x += vx * DeltaTime;
		}
	}
	
	{
		y += vy * DeltaTime;

		const auto ix = static_cast< int >( x );
		const auto iy = static_cast< int >( y );
		const auto curTileX = ix / TileSize;
		const auto curTileY = iy / TileSize;
		const auto nextTileY = curTileY + 1;

		if( ( Brd.GetTileType( curTileX, curTileY ) == Board::Type::filled ) ||
			( Brd.GetTileType( curTileX, nextTileY ) == Board::Type::filled ) )
		{
			vy = -vy;
			y += vy * DeltaTime;
		}
	}
}

void Enemy::Draw(Graphics & gfx) const
{
	gfx.DrawCircle(int(x), int(y), size, edgeColor);
	gfx.DrawCircle(int(x), int(y), size - padding, bodyColor);
}

float Enemy::GetX() const
{
	return x;
}

float Enemy::GetY() const
{
	return y;
}
