#pragma once

#include "Graphics.h"
#include "Board.h"

class Enemy
{
public:
	Enemy() = default;
	Enemy( float x_in, float y_in, float vx_in, float vy_in );
	void Move( Board &Brd, int TileSize, float DeltaTime );
	void Draw(Graphics& gfx) const;
	float GetX() const;
	float GetY() const;

private:
	float y;
	float x;
	float vy;
	float vx;
	static constexpr int padding = 2;
	static constexpr int size = 5;
	static constexpr auto edgeColor = Colors::MakeRGB( 195, 195, 195 );
	static constexpr auto bodyColor = Colors::MakeRGB( 0, 170, 169 );
};