#include "GameData.h"
#include "PlayingState.h"


GameData::GameData( Keyboard & Kbd )
	:
	m_keyboard( Kbd ),
	rng( std::random_device()( ) ),
	m_stateManager( std::make_unique<PlayingState>( *this ) )
{
}

void GameData::NewEnemy()
{
	std::uniform_real_distribution<float>xDist( 100.0f, 600.0f );
	std::uniform_real_distribution<float>yDist( 100.0f, 450.0f );
	std::uniform_real_distribution<float>xVelDist( 120.0f, 240.0f );
	std::uniform_real_distribution<float>yVelDist( 120.0f, 240.0f );

	enemy.push_back( { xDist( rng ), yDist( rng ), xVelDist( rng ), yVelDist( rng ) } );
}

