#include "GameStateManager.h"
#include "GameState.h"


GameStateManager::GameStateManager( std::unique_ptr<GameState>&& pState )
	:
	m_pState( std::move( pState ) )
{
}

GameState * GameStateManager::GetState()
{
	return m_pState.get();
}

void GameStateManager::Transition( std::unique_ptr<GameState>&& pNextState )
{
	m_pState = std::move( pNextState );
}

