#include "NewLevel.h"
#include "GameData.h"
#include "PlayingState.h"

NewLevel::NewLevel( GameData &Data )
	:
	GameState( Data ),
	newLevelUpdate( pause )
{
}

void NewLevel::Update( float DeltaTime )
{
	newLevelUpdate.Update( DeltaTime, [ this ]
	{
		m_data.player.Reset();
		m_data.brd.Reset();
		m_data.NewEnemy();
		m_data.enemyCount++;
		m_data.outEnemy.Reset();
		m_data.m_keyboard.FlushKey();
		m_data.m_stateManager.Transition(
			std::make_unique<PlayingState>( m_data ) 
		);
	} );
}
