#include "OutsideEnemy.h"

void OutsideEnemy::Move( Board & Brd, float DeltaTime )
{
	{
		x += vx * DeltaTime;
		const auto ix = static_cast< int >( x );
		const auto iy = static_cast< int >( y );
		const auto curTileX = ix / size;
		const auto curTileY = iy / size;
		const auto nextTileX = curTileX + 1;

		const int right = ix + size;

		if( Brd.GetTileType( curTileX, curTileY ) == Board::Type::empty ||
			Brd.GetTileType( nextTileX, curTileY ) == Board::Type::empty ||
			ix < 0 || right > Graphics::ScreenWidth )
		{
			x -= vx * DeltaTime;
			vx = -vx;
			x += vx * DeltaTime;
		}
	}
	{
		y += vy * DeltaTime;

		const auto ix = static_cast< int >( x );
		const auto iy = static_cast< int >( y );
		const auto curTileX = ix / size;
		const auto curTileY = iy / size;
		const auto nextTileY = curTileY + 1;

		const int bottom = int( y ) + size;
		if( Brd.GetTileType( curTileX, curTileY ) == Board::Type::empty ||
			Brd.GetTileType( curTileX, nextTileY ) == Board::Type::empty ||
			iy < 0 || bottom > Graphics::ScreenHeight )
		{
			y -= vy * DeltaTime;
			vy = -vy;
			y += vy * DeltaTime;
		}
	}
}

void OutsideEnemy::Draw( Graphics & gfx ) const
{
	gfx.DrawRect( int( x ), int( y ), size, size, edgeColor );
	gfx.DrawRect( int( x ) + padding, int( y ) + padding, size - ( padding * 2 ),
				  size - ( padding * 2 ), bodyColor );
}

float OutsideEnemy::GetX() const
{
	return x;
}

float OutsideEnemy::GetY() const
{
	return y;
}

void OutsideEnemy::Reset()
{
	y = 0.0f;
	x = 450.0f;
	vy = 240.0f;
	vx = 240.0f;
}
